#!/usr/bin/perl

#Configuartion File having the Site specific Configuration
$CONFIGURATION_FILE = "/opt/gridview/etc/gridview-ftsok-conf.pl";
$WSPUBLISHER_LIB_FILE = "/opt/gridview/sbin/gridview-common-wsclient.pl";

##############################################
#                                            #
#  Please Do not change below this Line      #
#                                            #
##############################################         

#Version of this Publisher. Please Do not change it!!!!!!!
$CONF_VERSION = "1.1.0";

#include the configuration File
do $CONFIGURATION_FILE;

##############################################
#                                            #
#        Setting the Default Values          #
#                                            #
##############################################         

#BASE_LOG_FILE_NAME is used to define the file name of the log file.
#It is BASE bcause in case of Log rotated files the filename is regenerated
#by appending a number to the BASE_LOG_FILE_NAME
$CONF_BASE_LOG_FILE_NAME = "/var/log/glite/glite-transfer-fts/publishing/gridview.dat";

#MAX_SLEEP_SECOND is used to define the max number of second that 
#program should sleep in case of no records available. 
$CONF_MAX_SLEEP_SECONDS = 60;

#Temporary directory where the publisher should unzip the logrotated files
$CONF_UNZIP_TMP_DIR = "/tmp/";

#File to keep the state of the Publisher. 
#This is to avoid publishing records that are already published.
$CONF_STATEFILE = "/opt/gridview/misc/gridview-ftsok-wsclient.state";

#File to keep the lock for the Publisher.
#This is used to avoid the other instance to start if there is one 
#already running
$CONF_LOCKFILE = "/opt/gridview/misc/gridview-ftsok-wsclient.lock";

#File to keep the log of the Publisher itself
#This is used to log the events of Publisher 
#amount of data written to the file is governed by LOG_LEVEL
$CONF_LOGFILE = "/opt/gridview/log/gridview-ftsok-wsclient";

#WSDL of the Web Service archiver of Gridview.
$CONF_SERVER_WSDL = "http://gvarch.cern.ch:8080/wsarch/services/WebArchiverAdv?wsdl";

#This is the timeout in minutes for detecting the process to be Hanged
$CONF_TIMEOUT = 30;

#This is the Wat Time in minutes that parent process has to wait
#for creating a new child if the child has exited.
$CONF_RETRY_WAIT = 5;

#LOG_LEVEL defines the verbosity of the Publisher
$CONF_LOG_LEVEL = 5;

#DEBUG_LEVEL this value defines where the logs are to written.
# For 0 = only to file, 1 = only to screen, 2 = to screen and File both
#This Option is not available to configuration.
$CONF_DEBUG = 0;

#Setting the TimeZone to UTC to have the same time format
$ENV{TZ} = "UTC";

#TABLE_NAME is the name of table that is used by the archiver 
#to know which table to use
$CONF_TABLE_NAME = "ftsokjobs";

#TUPLE_ORDER defines the order in which the tuples are to be published.
#Please don't change this without permission of Gridview Team
@CONF_TUPLE_ORDER = ('FTS_ID', 'FID', 'LOGDATE', 'JOB_ID', 'FILE_ID', 'VO_NAME', 'CHANNEL_NAME', 'FILE_SIZE', 'FINISH_TIME', 'SOURCE_SURL', 'DEST_SURL', 'SOURCE_HOST', 'DEST_HOST', 'SOURCE_SITE', 'DEST_SITE');


#Including the Library File that holds all the library functions
do $WSPUBLISHER_LIB_FILE;

&main;

#This function  returns the header of the WS publisher
sub getHeader {
#	return "H" . "$FTS_ID";
	return "";
}

#Parses the Line and breaks them in fields to be used to make string 
#to be published
#Specific to the FTS log file format.
sub parseLine
{
        my $inline = shift;
	my %record;

	#This regular Expression is for Parsing Each Record of FTS log

        if( $inline !~ /\s*(.*)\|(.*)\|(.*)\|(.*)\|(.*)\|(.*)\|(.*)\|(.*)\|(.*)\|(.*)\|(.*)\|(.*)\|(.*)\|(.*)\s*/)
        {
                &logMessage (5, "parseLine: Error Input Line not matches $inline");
                $record{GRIDVIEW_PUBLISHER} = "GRIDVIEW_PUBLISHER_ERROR: parseLine No Match: $inline";
                return %record;
        }
        &logMessage(6, "parseLine: After breakup from Reqular Expression $1 $2 $3 $4 $5 $6 $7 $8 $9 $10 $11 $12 $13 $14 ");
        $record{FID}   = $1;   $record{LOGDATE}   = $2;
        $record{JOB_ID} = $3;   $record{FILE_ID}   = $4;
        $record{VO_NAME}  = $5;   $record{CHANNEL_NAME}   = $6;
        $record{FILE_SIZE} = $7;   $record{FINISH_TIME} = $8;
        $record{SOURCE_SURL}  = $9;   $record{DEST_SURL} = $10;
        $record{SOURCE_HOST} = $11;  $record{DEST_HOST}= $12;
        $record{SOURCE_SITE} = $13;  $record{DEST_SITE}= $14;
	
	#setting the FTS Instance ID 
	my $envfts = $ENV{GRIDVIEW_FTS_INSTANCE};
	$envfts =~ s/^\s+//;
	$envfts =~ s/\s+$//;
	if( length($envfts) > 0){
		$record{FTS_ID} = $envfts;
	}
	else{
		$record{FTS_ID} = $FTS_ID;
	}

	&logMessage(6, "parseLine: Succesfully Parsed the line $inline");
	$record{GRIDVIEW_PUBLISHER} = "GRIDVIEW_PUBLISHER_PUBLISH: parseLine Success";
	return %record;
}

